/*

f-cpu/qdcpoc/execution.c
created Wed Jul 11 03:09:29 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG all rights reserved. you're warned !!!

this file is included in f-cpu/qdcpoc/main.c

*/

void fc0_cycle_ASU1() {
}

void fc0_cycle_ASU2() {
}


void fc0_cycle_ROP2() {
  UMAX t5, /* t5bis, t6,*/ tAND, tOR, tMUX;
/*  int i;
  unsigned char c; */

  if (Xbar_EU_ROP2 !=0) {

    /* The ROP2 operation */
    t5 = (ROP2_function_bit0 & ~Xbar_read_port0 & ~Xbar_read_port1)
       | (ROP2_function_bit1 & ~Xbar_read_port0 &  Xbar_read_port1)
       | (ROP2_function_bit2 &  Xbar_read_port0 & ~Xbar_read_port1)
       | (ROP2_function_bit3 &  Xbar_read_port0 &  Xbar_read_port1);

    /* MUX opcode : */
    tMUX = (Xbar_read_port0 &  Xbar_read_port2)
         | (Xbar_read_port1 & ~Xbar_read_port2);

#ifdef DIRTY_DONT_LOOK
    /* bytewide AND and OR */
    t5bis = t5;
    t6 = 0xFFLL;
    tAND = 0;
    tOR = 0;
    for (i=0; i<8; i++) {
      c = t5bis; /* i hope it's the LSB */
      if (c == 0xFF)  /* AND */
        tAND |= t6;
      if (c != 0)    /* OR */
        tOR |= t6;
      t5bis >>= 8;
      t6 <<= 8;
    } /* There MUST be a way to do that more cleanly ! */
#else
  /* a far better idea : */
  tAND = t5 & (t5 >> 1) & (t5 >> 2) & (t5 >> 4);
  tAND &= 0x0101010101010101LL;
  tAND |= (tAND << 1);
  tAND |= (tAND << 2);
  tAND |= (tAND << 4);

  tOR = t5 | (t5 >> 1) | (t5 >> 2) | (t5 >> 4);
  tOR &= 0x0101010101010101LL;
  tOR |= (tOR << 1);
  tOR |= (tOR << 2);
  tOR |= (tOR << 4);

#endif


    /* The final MUX : (this is not optimised for computing efficiency) */
    switch (Xbar_ROP2_mode) {
      case 0:  Xbar_ROP2_port = t5;    break; /* 0: normal */
      case 1:  Xbar_ROP2_port = tAND;  break; /* 1: AND */
      case 2:  Xbar_ROP2_port = tOR;   break; /* 2: OR */
      case 3:  Xbar_ROP2_port = tMUX;  break; /* 3: MUX */
      default: fprintf(stderr,"Error in Case"); exit(13);
    }
    Xbar_EU_ROP2 = 0;
  }
}

  /* others to come */
