# OPTIONS FOR CALLING BISON : (from info file)
#`-o OUTFILE'
#     Specify the name OUTFILE for the parser file.
#     The other output files' names are constructed from OUTFILE as
#     described under the `-v' and `-d' options.
# '-d'
# '--defines'
#     Write an extra output file containing macro defini
#     tions for the token type names defined in the gram
#     mar and the semantic value type YYSTYPE, as well as
#     a few extern variable declarations.
#
#     If the parser output file is named name.c then this
#     file is named name.h.
#
#     This  output  file  is essential if you wish to put
#     the definition of yylex in a separate source  file,
#     because  yylex  needs  to be able to refer to token
#     type codes and the variable yylval.
#
bison -d -o bison_ygasm.c ygasm.y

# OPTIONS FOR CALLING FLEX : (from flex.man)
#  -ofilename : write the resulting scanner to filename
flex -oflex_ygasm.c ygasm.l

# GCC : with all warnings on and debugging enabled.
gcc ygasm.c -g -W -Wall -ansi -o ygasm

echo "## nbdYG : gcc's complains about \`yyunput' are not worrisome."

# cleanup :
#rm bison_ygasm.*
#rm flex_ygasm.c
